# Copyright (C) 2018, 2019 Nathan Matthew Miller

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import tkinter as tk

from TkGUI import EditView, EditModel, EditController, EditCatModel

class Editor:

    def __init__( self, kb, link_id, entity_id ):

        entity_type = kb.retrieve_entity_type( entity_id )

        top = tk.Toplevel( takefocus=True )

        # Connect up the MVC pieces
        #
        ctrl  = EditController.Controller( kb, top, link_id )
        view  = EditView.View( top, ctrl, entity_type )
        
        if entity_type == 'K':
            model = EditModel.Model( view )
        else:
            model = EditCatModel.Model( view )
        
        ctrl.set_model( model )
        
        ctrl.load_entity( entity_id )

        view.clear_modified()
        return
    
