# Copyright (C) 2018, 2019 Nathan Matthew Miller

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import tkinter as tk
from tkinter import simpledialog

from TkGUI.Editor import *

class Controller:

    def __init__( self, root, kb ):

        self.root = root
        self.kb   = kb

        # This variable is used to pass entity IDs between editor windows for
        # the purpose of creating relationships between entities and adding
        # entities to a category.
        #
        self.link_id = tk.StringVar()

        return


    def search_kb( self, phrase ):

        cur = self.kb.search( phrase )
        self.results = cur.fetchall()
        
        return self.results


    def set_view( self, view ):

        self.view = view


    # Load an existing entity.
    #
    def show_entity( self, id ):

        Editor( self.kb, self.link_id, entity_id = id )
        return


    # A new knowledge fragment is being created.
    #
    def new_frag( self ):

        frag_name = simpledialog.askstring( "Enter KF Name", "Name",
                                            parent=self.root )

        if frag_name != None and len(frag_name) > 0:
            kf_id = self.kb.kf_create( name=frag_name, content="" )
            Editor( self.kb, self.link_id, entity_id=kf_id )
        return


    # A new category is being created.
    #
    def new_cat( self ):

        cat_name = simpledialog.askstring( "Enter Category Name", "Name",
                                           parent=self.root )

        if cat_name != None and len(cat_name) > 0:
            cat_id = self.kb.category_create( cat_name )
            Editor( self.kb, self.link_id, entity_id=cat_id )
        return
