#!/usr/bin/env python3

# Copyright (C) 2018, 2019 Nathan Matthew Miller

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import sys

import KB.Core as core


## Main program

if not len(sys.argv) > 1:

    sys.stderr.write( "No arguments provided\n" )
    sys.exit( 1 )

kb = core.Core()

name = content = None

if len(sys.argv) == 2:
    content = sys.argv[1]
else:
    name    = sys.argv[1]
    content = sys.argv[2]

id = kb.kf_create( name, content )
print( id )

kb.close()
sys.exit( 0 )
