#!/usr/bin/env python3

# Import pre-existing data into the knowledge base.

# Copyright (C) 2018, 2019 Nathan Matthew Miller

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

import sys
import os.path

import KB.Core as core
import KB.Import as imp

try:
    kb = core.Core()
except Exception as error:

    sys.stderr.write( "Trouble opening KB: " + str(error) + "\n" )
    sys.exit( 1 )

directory = os.path.expanduser( sys.argv[1] )

errors = imp.org_import_dir( kb, directory )

if len(errors) > 0:

    sys.stderr.write( "These file had import errors:\n")
    
    for error in errors:
        sys.stderr.write( error[0] + ": " + error[1] + "\n" )
        
kb.close()
